/***************************************************************************
                          divider.c  -  description
                             -------------------
    begin                : Tue Jan 6 2004
    copyright            : (C) 2004 by NZG
    email                : ngustavson@emacinc.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <asm/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <E12user.h>
#include <packet.h>
#include <coprocessor.h>
#include <counter.h>

#define ARGCHECK(num){if(argc!=num){printf("invalid number of arguements\n");help();return -1;}}

#define OPENDEV(filed,dev){if((filed = open(dev, O_RDWR))<=0){printf("couldn't open %s\n",dev);return -1;}}

static int help(void)
{
const char *help_table = "***************************************************
*divider                                          *
*Nathan Z. Gustavson                              *
*EMAC.Inc                                         *
*"__DATE__"                                      *
*usage:                                           *
*divider device in out divide                     *
*ex:                                              *
*divider /dev/37e12 0 1 100                       *
*divides the input of digital 0 by 100 on digital1*
***************************************************\n";
printf("%s",help_table);
return 0;
}

int main(int argc, char **argv)
{
int fd;
int in, out, divide;
unsigned char mask;
int data;

Cop_Data *Cop;
ARGCHECK(5);
OPENDEV(fd,argv[1]);
in = strtoul(argv[2],NULL,0);
out = strtoul(argv[3],NULL,0);
divide = strtoul(argv[4],NULL,0);
mask = 1<<out;
data = mask;
//configure ports
Cop = CopDeviceCreate(0);
E12_Digital_Cfg(fd, mask,0); //configure output port line to output
E12_CountConfig(fd, in, ANYE, divide,AUTOLOAD|ANOTE,Cop);
E12_CountCommand(fd, in,ICSTART);
while(1)
  {
    E12_Parse_Until(fd, Cop, NOTIFYRESPONSE);
    E12_Digitalout(fd,data,0);
    data = ((~data)&(mask));
  }
CopDeviceDestroy(Cop);
close(fd);
return 0;
}
